<!DOCTYPE html>
<html>
<head>
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
	<title>Bootstarp Flex</title>
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>
	<h1 class="text-center my-5">Bootstrap Flex</h1>

<!-- Flexbox is used to manipulate and layout our elements. This can be done exclusively in CSS, using bootstrap it is much easier and faster to implement flex because all we have to do is add the the class d-flex to the parent of our flex items.

flex items, flex children, when adding d-flex to their parent, the items become inline and they are in a row.


Flex Directions:

You can change the direction of your flex items by adding flex-direction, however, by default, flex-row is the arrangement of our flex items.

Flex Row Reverse

 -->


 <h3 class="text-center">Flex Row</h3>
	<div class="bg-dark d-flex mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Flex Items, Flex Children, when adding d-flex to their parent, the items are in a row. We can adjust their height and width not like your inline elements. -->

	<div class="bg-dark d-flex mb-4">
		<span class="bg-primary p-2">Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>
<!-- 

Flex Rows Reverse
Starts our item from the opposite side (right) and reverses the orders of our flex items.

flex-row starts from left to right (default).
flex-row-reverse starts from right to left.

Flex Column
Flex column will arrange our items from top to bottom and by default the flex items will occupy the width of its parent.

Flex Column reverse does the same as flex column but its from bottom to top

 -->
	<h3 class="text-center my-5">Flex Row Reverse</h3>
	<div class="d-flex flex-row-reverse bg-dark mb-4" style="height: 80vh;">
		<div class="bg-primary p-2">Flex Item reverse 1</div>
		<div class="bg-danger p-2">Flex Item reverse 2</div>
		<div class="bg-success p-2">Flex Item reverse 3</div>
	</div>
	<h3 class="text-center my-5">Flex Column</h3>
	<div class="d-flex flex-column bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-column mb-4 p-4">
		<span class="bg-primary p-2" style="height:300px; width: 300px;">Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>

	<h3 class="my-5 text-center"> Flex Column Reverse</h3>
	<div class="bg-dark d-flex flex-column-reverse mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


	<!-- Justify Content -->
	<h2 class="text-center my-5">Justify Content</h2>
	<h3 class="text-center my-5">Justify Content Start</h3>
	<!-- Justify-content allows us to manipulate and change the alignment of our flex items along our main axis. The main axis for flex-row item is our x-axis. Justify content allows us to horizontally align our flex-row items  -->

	<!-- justify-content-start the default value of justify content for flex items. It allows us to align our flex items to the start of their main axis. For flex-row it starts from the left, for flex-row-reverse it starts from the right -->

	<div class="bg-dark d-flex flex-row justify-content-start bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-start bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- justify-content-start -->
	<h3 class="text-center my-5">Justify Content End</h3>
	<!-- Aligns our flex items where our main axis ends. For flex-row, the end from the right, the flex-row-reverse start with the left. -->
	<div class="bg-dark d-flex flex-row justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Justify Content Center</h3>
	<!-- justify-content-center aligns our flex-items at the center of the main axis. The main axis for both flex-row -->
	<div class="bg-dark d-flex flex-row justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Justify Content Between</h3>
	<!-- justify-content-between = adds or distribute the remaining spaces in between items -->
	<div class="d-flex flex-row justify-content-between bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<div class="d-flex flex-row-reverse justify-content-between bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

	<h3 class="text-center my-5">Justify Content Around</h3>
	<!-- justify-content-around aligns items by distributing space around your items. Maning it will automatically calculate the space and add that space around your items. -->
	<div class="bg-dark d-flex flex-row justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- align items -->

	<h2 class="text-center">Align Items</h2>
	<!-- align-items aligns your items vertically for flex-row and flex-row-reverse -->
	<h3 class="text-center">Align Items Start</h3>
	<!-- align-items-start = aligns items at the start of the y axis or cross-axis for flex-row and flex-row-reverse.

	For flex-row and flex-row-reverse, the y-axis is the cross axis and the x-axis is their main axis.

	For flex-column and flex-column-reverse, the y-axis.


	 -->
	<div class="d-flex flex-row align-items-start bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-start bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Align Items End</h3>
	<!-- align-items-end will align our flex-row and flow-reverse to the bottom of the div. -->
	<div class="d-flex flex-row align-items-end bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		
	</div>
	<div class="d-flex flex-row-reverse align-items-end bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Align Items center</h3>
	<div class="d-flex flex-row align-items-center bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-center bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h2 class="text-center">Aligning Items horizontally and Vertically</h2>
	<div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Mini Activity -->
	<h3 class="text-center my-5">Mini-Activity with flex Row</h3>
	<div class="d-flex flex-row bg-dark align-items-center justify-content-center my-5" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row bg-dark align-items-center justify-content-between my-5" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


	<h2 class="text-center">Flex Column with Align Items and Justify Content</h2>
	<div class="d-flex flex-column align-items-center bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2" style="width:30%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:30%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:30%;">Flex Item 3</div>
	</div>
	<div class="d-flex flex-column justify-content-center bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>

<!-- For flex-row and flex-row-reverse, align-items aligns our flex-row and flex-row reverse vertically, justify-content align and our flex-row and flex-row reverse horizontally.

for flex-column and flex-column-reverse, align-items aligns our flex-column and flex-column-reverse horizontally,  justify-content aligns our flex-column and flex-column-reverse vertically.

 -->

 <h3 class="text-center">Mini Activity with Flex Column</h3>
 <div class="bg-dark mb-4 d-flex flex-column justify-content-end" style="height: 50vh;">
 		<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
		<div class="bg-success p-2" style='width: 20%;'>Flex Item 3</div>
 </div>
<div class="bg-dark mb-4 d-flex flex-column align-items-end" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
</div>


 <h3 class="text-center">Justify Column with Justify Content Between and Around</h3>
 <div class="bg-dark mb-4 d-flex flex-column justify-content-between" style="height: 50vh;">
 		<div class="bg-primary p-2" style="width: 20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
		<div class="bg-success p-2" style='width: 20%;'>Flex Item 3</div>
 </div>
<div class="bg-dark mb-4 d-flex flex-column justify-content-around" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
</div>

<h3 class="text-center">Flex Wrap</h3>
<div class="d-flex flex-row flex-wrap bg-dark mb-4 justify-content-around">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>

</div>

<!-- Mini Activity -->





	<!-- JS dependencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>